Graphics 800,600,32,2
SetBuffer BackBuffer()


Seed=MilliSecs()

TileWide=32
TileHigh=32
Totframes=TileHigh*8	;<--  This value	<	<	<	<<
						;								 ^
ShiftFrameDownEvery=4	;These values must be factors of ^
ShiftFrameLeftEvery=8
ShiftFrameUpEvery=0		;A 0 means not to bother.
ShiftFrameRightEvery=0

Noticability=15	;Blue Color=Rand(120,120+This) so don't go over 135!
Density=TileWide*6	; How many pixels it plots per loop.

HorizontalWave#=0.5	; -Cos(Angle)*This
VerticalWave#=1.5	; +Sin(Angle)*This

HorizontalOffset#=52	;Distance between each pixel
VerticalOffset#=62		

ClearPlain=False	;Set to True to see how you wave looks whilst tweaking



;---------------------------

frames=CreateImage(TileWide,TileHigh,TotFrames)

water=CreateImage(TileWide,TileHigh)

temp=CreateImage(TileWide,TileHigh)


;First, make a nice blue background
SetBuffer ImageBuffer(water)
For n=1 To 100000
d=Rand(120,120+Noticability)
Color d/4,d/4,d
Plot Rand(0,TileWide-1),Rand(0,TileHigh-1)
Next

;Then Loop once...
For f=0 To totframes-1
	Gosub DoShift
	Gosub AddTrickle
	If ClearPlain=True Then Cls
Next

;And then loop through again, drawing over to make it a complete repeating animation.
For f=0 To totframes-1
	Gosub DoShift
	Gosub AddTrickle
	CopyRect 0,0,TileWide,TileHigh,0,0,ImageBuffer(water),ImageBuffer(frames,f)
Next


n=0
Repeat
SetBuffer BackBuffer()

Cls
n=n+1:If n=totframes Then n=0

TileImage frames,0,0,n

Flip
Until KeyDown(1)


Cls
x=0
y=0
For f=0 To totframes-1
DrawImage frames,x,y,f

x=x+TileWide
If x=>800 Then x=0:y=y+TileHigh
Next

SaveBuffer BackBuffer(),"WaterTiles.bmp"

Flip
Delay 1500
End


.doShift
If ShiftFrameDownEvery>0
	If (f Mod ShiftFrameDownEvery)=0
		CopyRect 0,TileHigh-1,TileWide,1,0,0,ImageBuffer(water),ImageBuffer(temp)
		CopyRect 0,0,TileWide,TileHigh-1,0,1,ImageBuffer(water),ImageBuffer(water)
		CopyRect 0,0,TileWide,1,0,0,ImageBuffer(temp),ImageBuffer(water)
	EndIf
EndIf

If ShiftFrameUpEvery>0
	If (f Mod ShiftFrameUpEvery)=0
		CopyRect 0,0,TileWide,1,0,0,ImageBuffer(water),ImageBuffer(temp)
		CopyRect 0,1,TileWide,TileHigh-1,0,0,ImageBuffer(water),ImageBuffer(water)
		CopyRect 0,0,TileWide,1,0,TileHigh-1,ImageBuffer(temp),ImageBuffer(water)
	EndIf
EndIf

If ShiftFrameRightEvery>0
	If (f Mod ShiftFrameRightEvery)=0
		CopyRect TileWide-1,0,1,TileHigh,0,0,ImageBuffer(water),ImageBuffer(temp)
		CopyRect 0,0,TileWide-1,TileHigh,1,0,ImageBuffer(water),ImageBuffer(water)
		CopyRect 0,0,1,TileHigh,0,0,ImageBuffer(temp),ImageBuffer(water)
	EndIf
EndIf

If ShiftFrameLeftEvery>0
	If (f Mod ShiftFrameLeftEvery)=0
		CopyRect 0,0,1,TileHigh,0,0,ImageBuffer(water),ImageBuffer(temp)
		CopyRect 1,0,TileWide-1,TileHigh,0,0,ImageBuffer(water),ImageBuffer(water)
		CopyRect 0,0,1,TileHigh,TileWide-1,0,ImageBuffer(temp),ImageBuffer(water)
	EndIf
EndIf

Return


.AddTrickle
SeedRnd Seed
SetBuffer ImageBuffer(water)
For n=1 To Density
	d=Rand(120,120+Noticability)
	Color d/4,d/4,d
	Plot ((TileWide/2)+Rand(-1,1))+(Sin(( (f*Float(Float(360)/Float(totframes)) )*VerticalWave ) + n*VerticalOffset )*((TileWide/2)+2)),((TileHigh/2)+Rand(-1,1))-(Cos((f* (Float(Float(360)/Float(totframes)) )*HorizontalWave ) + n*HorizontalOffset )*((TileHigh/2)+2))
Next
Return